# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

from typing import Optional, Union

from ansys.rocky.core._api_stubs.plugins10.plugins.api.api_element_item import (
    ApiElementItem,
)
from ansys.rocky.core._api_stubs.rocky30.plugins.api.ra_addins import (
    ElementWithAddins as ElementWithAddins,
)
from ansys.rocky.core._api_stubs.rocky30.plugins.api.ra_solid_material import (
    RASolidMaterial as RASolidMaterial,
)

class RAMaterialsInteraction(ApiElementItem, ElementWithAddins):
    @classmethod
    def GetWrappedClass(self): ...
    @classmethod
    def GetClassName(self) -> str: ...
    def GetFirstMaterial(self) -> RASolidMaterial: ...
    def GetSecondMaterial(self) -> RASolidMaterial: ...
    def GetAdhesiveDistance(self, unit: Optional[str] = ...) -> float: ...
    def SetAdhesiveDistance(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetAdhesiveFraction(self, unit: Optional[str] = ...) -> float: ...
    def SetAdhesiveFraction(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetContactStiffnessMultiplier(self, unit: Optional[str] = ...) -> float: ...
    def SetContactStiffnessMultiplier(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetRestitutionCoefficient(self, unit: Optional[str] = ...) -> float: ...
    def SetRestitutionCoefficient(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetDynamicFriction(self, unit: Optional[str] = ...) -> float: ...
    def SetDynamicFriction(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetStaticFriction(self, unit: Optional[str] = ...) -> float: ...
    def SetStaticFriction(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetSurfaceEnergy(self, unit: Optional[str] = ...) -> float: ...
    def SetSurfaceEnergy(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetTangentialStiffnessRatio(self, unit: Optional[str] = ...) -> float: ...
    def SetTangentialStiffnessRatio(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetVelocityExponent(self, unit: Optional[str] = ...) -> float: ...
    def SetVelocityExponent(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetVelocityLimit(self, unit: Optional[str] = ...) -> float: ...
    def SetVelocityLimit(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
